var isInProcess = false;

function showProcess(firstmessage, iserror){


    var df = UIkit.modal($("#modal-center"));
    df.bgClose = false;
    df.show();

    var errorsfield = $("#errors-area");

    if(firstmessage)  errorsfield.val(firstmessage);

    var progressbar = $("#js-progressbar");
    progressbar.val(1);

    if(!iserror){
        //отправляем запрос за прогрессом и возникшими ошибками каждые 5 секунд, пока прогресс обработк и записей не достигнет 100%
        var percentage = 0;

        var timerId = setInterval(function(){

            $.ajax({
                url: window.location.origin + "/import/api/registry/info",
                type: 'GET',
                success: function (data) {
                    var str = "";
                    data.errors.forEach(function(item){
                        str += item;
                    });

                    $("#sucessfully_imported").html(data.imported);
                    $("#whole_amount").html(data.total);
                    errorsfield.val(str);

                    percentage = data.count / (data.total / 100);
                    progressbar.val(percentage);
                    if (data.count === data.total) return;
                },
                error: function (error) {
                    try {
                        var str2 = "";
                        var json = JSON.parse(error.responseText);
                        json.errors.forEach(function (item) {
                            str2 += item;
                        });
                        errorsfield.val(str2);

                        percentage = data.count / (data.total / 100);
                        progressbar.val(percentage);
                        if (data.count === data.total) return;
                    } catch(e){
                        errorsfield.val(e);
                        clearInterval(timerId);
                        isInProcess = false;
                        return;
                    }
                }
            });


            if(percentage >= 100){
                clearInterval(timerId);
                isInProcess = false;
                return;
            }

        }, 3000);

    }

};


$(document).ready(function(){
    $("#spin").hide();


    $('input[name=radio1]').change(function (){
        if($(this).val() == "0"){
            $(".def-hide").each(function(){
                $(this).removeClass("def-hide");
                $(this).addClass("def-show");
            })
        } else {
            $(".def-show").each(function(){
                $(this).removeClass("def-show");
                $(this).addClass("def-hide");
            })
        };

    });

    $("#instructions-button").click(function(){
        var instblock = $("#instructions-block");
        if(instblock.hasClass("ib-open")){
            instblock.removeClass("ib-open");
            instblock.addClass("ib-close");
        } else {
            instblock.removeClass("ib-close");
            instblock.addClass("ib-open");
        }
    });


    $(".start_import").click(function(){

        $("#js-progressbar").val(0);
        $("#sucessfully_imported").html("");
        $("#whole_amount").html("");

        if(isInProcess){
            showProcess();
        } else {
            var formCode = $("#formCode").val();
            var regCode = $("#registryCode").val();
            if(!formCode || !regCode){
                UIkit.modal.alert("Необходимо ввести код формы и код реестра!");
            } else {
                var log = $("#login").val();
                var pass = $("#password").val();
                var action = $('input[name=radio1]:checked').val();
                var defaultValue = $('#default-value').val();
                var searchString = $('#search-value').val();
                var shouldPasteMeaningValue = $('#shouldPasteMeaningValue').is(':checked');

                if (!defaultValue) {
                    defaultValue = "none";
                }

                if (!searchString) {
                    searchString = "none";
                }

                var isActivate = $("#activate").is(':checked');

                var file = $("#fileinpt");
                var fd = new FormData;

                fd.append('file', file.prop('files')[0]);

                $.ajax({
                    url: window.location.origin + "/import/api/registry/import_file?formcode=" + formCode + "&registrycode=" + regCode
                        + "&activate=" + isActivate + "&action=" + action + "&defaultValue=" + defaultValue + "&searchString=" + searchString
                        + "&shouldPasteMeaningValue=" + shouldPasteMeaningValue,
                    data: fd,
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader("Authorization", "Basic " + btoa(log + ":" + pass));
                    },
                    processData: false,
                    contentType: false,
                    type: 'POST',
                    success: function (data) {
                        $("#spin").hide();
                        showProcess(data.message);
                        isInProcess = true;
                    },
                    error: function (error) {
                        $("#spin").hide();
                        if(error.code == 500) alert("Не создана папка /tmp/crm-import");
                        else alert(error.responseText);
                        isInProcess = false;
                    }

                });

            }
       }
    });

});



